unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.Grids, system.UITypes,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    LabeledEdit1: TLabeledEdit;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    LabeledEdit2: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    function LUecomposition: byte;
    procedure GridSet(Sin, Colin: integer);    // ObhTCYύX
    procedure rowmatinc(k: integer);
    procedure testset;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Nltest : integer = 4;             // eXgf[^[s
                                    // eXgf[^[
  mattestA : array[0..3] of array[0..3] of extended = ((8, 16, 24, 32),
                                                       (2,  7, 12, 17),
                                                       (6, 17, 32, 59),
                                                       (7, 22, 46,105));
  mattestB : array[0..3] of array[0..3] of extended = ((8, 16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  // ̃TvlLUΊp[ƂȂ̂łAZ덷ɂ[ɂȂȂlłB
  mattestC : array[0..3] of array[0..3] of extended = ((8, 16, 24,   0),
                                                       (2,  7, 12,   0),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  btestA    : array[0..3] of extended = (160, 70, 198, 291);
  btestB    : array[0..3] of extended = (150, 60, 10, 40);

  Nl : integer;                     // s
  matA : array of array of extended;  // Asz
  bakA : array of array of extended;  // Asz

  matL : array of array of extended;  // Lsz
  matU : array of array of extended;  // Usz
  lu   : array of array of extended;
  b    : array of extended;
  bakB : array of extended;
  ba   : array of extended;
  a    : array of array of extended;
  rowNo : array of integer;

  lc : integer;
  diagonal : integer;
  allowable_errorr : extended;
  epsilon : extended;

// Obh̐ݒ
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W, i :integer;                               // ȏ̓XN[
begin
  inc(Sin);
  inc(Colin);
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      StringGrid2.ScrollBars := ssNone;           // XN[o[\
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      StringGrid2.ScrollBars := ssVertical;       // XN[o[\
    end;
  if Colin <= 11 then                             // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * (10 + 1);
      StringGrid1.ScrollBars := ssBoth;           // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
  for i := 1 to Sin - 1 do StringGrid1.Cells[0,i] := 'a' + intTostr(i) + '*';
  for i := 1 to Sin - 1 do StringGrid1.Cells[i,0] := 'a*' + intTostr(i);
  StringGrid2.RowCount := Sin;
  StringGrid2.ClientHeight := H + 1;
  StringGrid2.ClientWidth := (StringGrid2.DefaultColWidth + 1) * 2;
  for i := 1 to Sin - 1 do StringGrid2.Cells[0, i] := intTostr(i);
  StringGrid2.Cells[1, 0] := 'b*=';
end;

// s̓ւ ΊpɃ[ɍs̓ւs܂B
procedure TForm1.rowmatinc(k: integer);
var
  ss : extended;
  i, m, p : integer;
begin
  p := k - 1;                    // p k̏̍s
  if p < 0 then p := Nl + p;     // k0ԏ̎p3ԉ
  for i := 0 to Nl - 1 do begin  // ̍spƉ̍sk
    ss := matA[k, i];
    matA[k,i] := matA[p, i];
    matA[p, i] := ss;
  end;
  ss := b[k];
  b[k] := b[p];
  b[p] := ss;
  m := rowNo[k];                 // sۑ
  rowNo[k] := rowNo[p];
  rowNo[p] := m;
end;

// LUɂẢ@
function TForm1.LUecomposition: byte;
const
  sp = ' ';
var
  i, j, k, n, h : integer;
  sum: extended;
  aa : array of array of extended;
  l, u, x, y: array of extended;
  LL, spl : string;
begin
  setlength(a, Nl, Nl);
  setlength(aa, Nl, Nl);

  setlength(l, Nl);
  setlength(u, Nl);
  setlength(x, Nl);
  setlength(y, Nl);

  // s̓ւNoҏWpɃRs[
  // matf[^[ҏWpɃRs[           matA, B
  for j := 0 to Nl - 1 do  begin
    ba[j ] := b[j];
    for k := 0 to Nl - 1 do a[j, k] := matA[j, k];
  end;

  memo1.Clear;

  // ҏWpobNAbvɂɃRs[
  for j := 0 to Nl - 1 do
    for k := 0 to Nl - 1 do
      aa[j, k] := a[j, k];

  // matȖΊp1ɐݒ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do
      if i = j then begin
        matU[i, j] := 1;
        matL[i, j] := 0;
      end
      else begin
        matU[i, j] := 0;
        matL[i, j] := 0;
      end;

  // LU
  for i := 0 to Nl -1  do begin
    n := Nl - i - 1;
    // matA擪̒lmatL̑ΊpɃZbg
    matL[i, i] := a[0, 0];
    // MatL̍쐬
    for j := 0 to n - 1 do begin
      l[j] := a[j + 1, 0];
      matL[j + i + 1, i] := l[j];
    end;
    // Ίp[I
    if a[0, 0] = 0 then begin
      break;
    end;
    // matU̍쐬
    for j := 0 to n - 1 do begin
      u[j] := a[0, j + 1] / a[0, 0];
      matU[i, j + i + 1] := u[j];
    end;
    // lu߂
    for j := 0 to n - 1 do begin
      for k := 0 to n - 1 do begin
        lu[j, k] := l[j] * u[k];
      end;
    end;
    // a߂
    for j := 0 to n - 1 do begin
      for k := 0 to n - 1 do begin
        a[j, k] := a[j + 1, k + 1] - lu[j, k];
      end;
    end;
  end;

  diagonal := Nl;

  // ΊpɃ[ꍇZ𒆎~'
  // s̓ւ݂܂
  if a[0, 0] = 0 then begin
    result := 1;
    diagonal := i;
    exit;
  end;

  // LUsŘA܂
  for i := 0 to Nl - 1 do begin
    sum := 0;
    for k := 0 to i - 1 do sum := sum + matL[i, k] * y[k];
    y[i] := (ba[i] - sum) / matL[i, i];
  end;
  // ޑ
  for i := Nl - 1 downto 0 do begin
    sum := 0;
    for k := i + 1 to Nl - 1 do sum := sum + matU[i, k] * x[k];
    x[i] := y[i] - sum;
  end;

  // es̍vZ
  for j := 0 to Nl - 1 do begin
    sum := 0;
    for i := 0 to Nl - 1 do begin
      sum := sum + aa[j, i] * x[i];
    end;
    y[j] := ba[j] - sum;
  end;

  // ZsNo\
  LL := 'vZ@';
  for i := 0 to Nl - 1 do begin
     if i < NL -1 then LL := LL + intTostr(rowNo[i] + 1) + ','
                  else LL := LL + intTostr(rowNo[i] + 1);
  end;
  memo1.Lines.Append(LL);

  // sԍ\
  memo1.Lines.Append('s No            Zɂ鍷');
  for k := 0 to Nl - 1 do begin
    LL := 'No = ' + inttostr(k + 1);
    n := 25 - length(LL);
    spl := '';
    for j := 1 to n do spl := spl + sp;
    LL := LL + spl + floattostr(y[rowNo[k]]);
    memo1.Lines.Append(LL);
  end;

  // 
  h := 0;
  for k := 0 to Nl - 1 do begin
    if abs(ba[k]) > allowable_errorr then sum := y[k] / ba[k]
                                     else sum := y[k];
    if abs(sum) > allowable_errorr then inc(h);
  end;

  if checkbox1.Checked = false then begin
    if h = 0 then memo1.Lines.Append('   OK')
             else memo1.Lines.Append('   NG');
    if h > 0 then begin
      result := 3;
      diagonal := 2;
      exit;
    end;
  end;

  // x̒l\
  for k := 0 to Nl - 1 do begin
    memo1.Lines.Append('X' + inttostr(k + 1) + '=' + floatTostr(x[k]));
  end;

  result := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j, ch, k : integer;
  maxb, minb, bc : extended;
  acmax : array of extended;
  acmin : array of extended;

  procedure sortdat;
  var
    k : integer;
  begin
    ch := 1;
    for k := 3 to Nl do ch := ch * k; // ő僋[vvZ _l1/2
    // LuẢ@  @łȂꍇ
    i := 0;
    j := 0;   // @łꍇ 0  oȂꍇ 1
    // LuɏI܂ŌJԂ
    for k := 1 to ch do begin
      lc := Nl;
      repeat
        j := LUecomposition;
        if  j = 1 then begin        // ΊpɃ[
          dec(lc);
          inc(i);
          rowmatinc(lc);            // s̈ړ
        end
        else lc := 0;
      until (lc <= 0) or (i >= ch);
      if (j = 0) or (i >= ch) then break;        // Ίpl 0  @@ŏI
    end;
  end;

begin
  setlength(matA, Nl, Nl);
  setlength(bakA, Nl, Nl);
  setlength(matL, Nl, Nl);
  setlength(b, Nl);
  setlength(bakb, Nl);
  setlength(ba, Nl);
  setlength(lu , Nl, Nl);
  setlength(matU, Nl, Nl);
  setlength(rowNo, Nl);
  setlength(acmax, Nl);
  setlength(acmin, Nl);

  // matAɃObh1lǂݍ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do begin
      val(StringGrid1.Cells[i + 1,j + 1],matA[j,i], ch);
      if ch <> 0 then begin
        MessageDlg('a' + intTostr(j + 1) + ',' + intTostr(i + 1) + ' ̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
        exit;
      end;
    end;
  // bɃObh2lǂݍ
  for i := 0 to Nl - 1 do begin
    val(StringGrid2.Cells[1, i + 1], b[i], ch);
    if ch <> 0 then begin
      MessageDlg('b' + intTostr(i + 1) + '̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
      exit;
    end;
  end;
  // Ze덷
  val(labelededit2.Text, allowable_errorr, ch);
  if ch <> 0 then begin
    MessageDlg('Z덷el̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  // As̍őlŏl
  for i := 0 to Nl -1 do begin
    acmax[i] := 1;
    acmin[i] := 1;
    if matA[i, 0] <> 0 then acmax[i] := abs(matA[i, 0]);
    if matA[i, 0] <> 0 then acmin[i] := abs(matA[i, 0]);
    for j := 1 to Nl - 1 do begin
      if (abs(matA[i, j]) > acmax[i]) and (matA[i, j] <> 0) then acmax[i] := abs(matA[i, j]);
      if (abs(matA[i, j]) < acmin[i]) and (matA[i, j] <> 0) then acmin[i] := abs(matA[i, j]);
    end;
  end;
  // BsAs̔ŏlƍől
  maxb := abs(b[0]) / acmax[0];
  minb := abs(b[0]) / acmin[0];
  for i := 1 to Nl - 1 do begin
    if abs(b[i]) / acmax[i] > maxb then maxb := abs(b[i]) / acmax[i];
    if abs(b[i]) / acmin[i] < minb then minb := abs(b[i]) / acmin[i];
  end;
  // b̒l͈̔͂Z͈̔͂zĂ邩
  bc := minb;
  if (minb = 0) and (maxb > 0) then
    if maxb >= 1 then bc := 1 / maxb
                 else bc := maxb;
  if (minb > 0) and (maxb > 0) then bc := minb / maxb;
  if (minb = 0) and (maxb = 0) then bc := 1;
  if checkbox1.Checked = false then
    if bc  < epsilon then begin
      MessageDlg('b̓͒l̒lZ͈̔͂𒴂Ă܂B', mtInformation,[mbOk], 0);
      memo1.Clear;
      exit;
    end;
  // Zʂ̔lݒ
  allowable_errorr := allowable_errorr * sqrt(bc);      // l

  for i := 0 to Nl -1 do begin        // ̓f[^[̃obNAbv
    bakb[i] := b[i];
    for j := 0 to Nl - 1 do
      bakA[i, j] := matA[i, j];
  end;

  for i := 0 to Nl - 1 do rowNo[i] := i;

  sortdat;                           // vZ
  if i >= ch then begin              // vZNGtvZ
    for k := 0 to Nl - 1 do begin
      rowNo[k] := Nl - 1 - k;
      b[rowNo[k]] := bakb[k];
      for j := 0 to Nl - 1 do
        matA[rowNo[k], j] := bakA[k, j];
    end;
    sortdat;
  end;

  // @oȂ
  if diagonal < Nl then begin
    MessageDlg('LU𒆂ɑΊp[܂A͒lĉB', mtInformation,[mbOk], 0);
    exit;
  end;
  if j <> 0 then begin
    memo1.Clear;
    memo1.Lines.Append('鎖o܂łB');
  end;
  memo1.Lines.Append('ČvZ Row= ' + intTostr(i));
end;

// eXgf[^[̑Iݒ
procedure TForm1.testset;
var
  i, j : integer;
begin
  GridSet(Nltest, Nltest);
  Nl := Nltest;
  for i := 1 to Nltest do
    for j := 1 to Nltest do begin
      case radiogroup1.ItemIndex of
        0: StringGrid1.Cells[i,j] := floatTostr(mattestA[j-1, i-1]);
        1: StringGrid1.Cells[i,j] := floatTostr(mattestB[j-1, i-1]);
        2: StringGrid1.Cells[i,j] := floatTostr(mattestC[j-1, i-1]);
      end;
    end;
  for i := 1 to Nltest do begin
    case radiogroup1.ItemIndex of
      0: StringGrid2.Cells[1,i]  := floatTostr(btestA[i-1]);
      1, 2 : StringGrid2.Cells[1,i]  := floatTostr(btestB[i-1]);
    end;
  end;
  LabeledEdit1.Text := intTostr(Nltest);
  memo1.Clear;
end;

// ObhTCY̕ύX
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch : integer;
begin
  val(LabeledEdit1.Text, Nl, ch);
  if ch <> 0 then begin
    MessageDlg('N̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  GridSet(Nl, Nl);
end;

// eXgf[^[Zbg
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  testset;
end;

// l̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  a: extended;
begin
  testset;
  epsilon := 1;
  repeat
    epsilon := epsilon / 2;
    a := 1 - epsilon;
  until a = 1;
  epsilon := epsilon * 2;
end;

end.
